'FEM計算の実行ﾌﾟﾛｸﾞﾗﾑ（ｽｶｲﾗｲﾝ法、主行列4個）
Imports System.Drawing

Public Class Th3DCal4
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.PictureBox2 = New System.Windows.Forms.PictureBox()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(120, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(256, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "熱伝導計算の実行（スカイライン法）"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(38, 12)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(144, 192)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(136, 24)
        Me.PictureBox1.TabIndex = 3
        Me.PictureBox1.TabStop = False
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(144, 136)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(260, 24)
        Me.PictureBox2.TabIndex = 4
        Me.PictureBox2.TabStop = False
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 248)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(400, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'Th3DCal4
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(496, 302)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.PictureBox2)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "Th3DCal4"
        Me.Text = "Th3DCal4"
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Dim SwK As IO.StreamWriter      '結果出力用

    Dim KTempCond As Integer        '非定常の境界による温度変化区分（-1:低下、0:不定、1:上昇）
    Dim NumEff As Integer           'FEM行列（右上三角）のｲﾝﾃﾞｯｸｽ数

    Dim Fw1, Fw2 As Single          '進行表示の水平枠位置
    Dim TempIniMax As Single        '非定常の初期温度の最高値
    Dim TempIniMin As Single        '非定常の初期温度の最低値

    Dim Idiag() As Integer          '元のFEM行列対角の保存ｲﾝﾃﾞｯｸｽ番号
    Dim KTempRange(2) As Integer    '最低・最高温度の節点番号 

    Dim Ek(20, 20) As Double        '要素計算の２次配列
    Dim Fc(), Em(20, 20) As Double  '非定常計算の追加配列
    Dim Qq(20) As Double            '内部発熱率の節点への換算量
    Dim Rkc(), Rmc() As Double      '非定常の行列
    Dim Rkr(), Fr() As Double       '熱放射用の配列
    Dim TempRange(2) As Single      '最低・最高温度
    Dim Tf() As Double              'FEM計算の右辺ﾍﾞｸﾄﾙ
    Dim Tk() As Double             'FEM行列の1次元保存配列
    Dim TTempRange(2) As Single     '最低・最高温度の時間
    Dim TUx() As Double             '前回の温度

    Private Sub Debug1(ByVal ie As Integer)
        '要素ﾏﾄﾘｯｸｽを出力して停止
        Dim aa$, fxx$
        Dim i, j, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\Th3DCal4debug1.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "要素マトリックスデータ"
        WriteLine(ii, aa$)
        aa$ = "要素" + Str$(ie)
        WriteLine(ii, aa$)
        For i = 1 To 20
            aa$ = "行" + Str$(i)
            WriteLine(ii, aa$)
            aa$ = Str$(Ek(i, 1))
            For j = 2 To 10
                aa$ = aa$ + "," + Str$(Ek(i, j))
            Next
            PrintLine(ii, aa$)
            aa$ = Str$(Ek(i, 11))
            For j = 12 To 20
                aa$ = aa$ + "," + Str$(Ek(i, j))
            Next
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug2(ByVal mh As Integer, ByVal nx As Integer)
        '主行列と右辺値を出力して停止
        '非0要素のみ出力
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, fxx$
        Dim i, ic, j, j2, ii, kx As Integer
        Dim z1 As Single
        ii = FreeFile()
        fxx$ = DirOpen$ + "\Th3DCal4debug2.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "主行列と右辺"
        WriteLine(ii, aa$)
        For i = 1 To Npoint
            aa$ = "行" + Str$(i)
            WriteLine(ii, aa$)
            j2 = i + mh - 1
            If j2 > nx Then
                j2 = nx
            End If
            ic = 0
            For j = i To j2
                kx = Idiag(j) - (j - i)
                If kx > Idiag(j - 1) Then
                    z1 = Tk(kx)
                    If z1 <> 0 Then
                        If ic = 0 Then
                            aa$ = Str$(j) + ",  " + Str$(z1)
                        Else
                            aa$ = aa$ + ",    " + Str$(j) + ",  " + Str$(z1)
                        End If
                        If ic = 4 Then
                            PrintLine(ii, aa$)
                            ic = 0
                        Else
                            ic = ic + 1
                        End If
                    End If
                End If
            Next j
            If ic > 0 Then
                PrintLine(ii, aa$)
            End If
            z1 = Tf(i)
            WriteLine(ii, "  右辺", Str$(z1))
        Next i
        FileClose(ii)
        Stop

    End Sub

    Private Sub Debug3()
        '解を出力して停止
        Dim aa$, fxx$
        Dim i, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\Th3DCal4debug3.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "解データ"
        WriteLine(ii, aa$)
        For i = 1 To Npoint
            WriteLine(ii, i, Str$(Tu(i)))
        Next i
        FileClose(ii)
        Stop

    End Sub

    Private Sub DtempCalc(ByRef dtempx As Double)
        '最大温度変化の計算
        'dtempx･･･最大温度変化値
        Dim i As Integer
        Dim b1 As Double
        dtempx = 0
        For i = 1 To Nall
            b1 = Math.Abs(Tu(i) - TUx(i))
            If b1 > dtempx Then
                dtempx = b1
            End If
        Next i
    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer)
        '要素マトリックスの計算
        'ie･･･要素番号
        Dim i, id, ig, ii, j, jg, k, kdiv, kg, kmat, nmax, numg As Integer
        Dim b1, b2, dj, dv, rc, rla, s, t, tempb, u As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            TE(ii) = Tu(Kcomp(i))
        Next ii
        For i = 1 To Nvar
            For j = i To Nvar
                Ek(i, j) = 0
                If Mstat > 0 Then
                    Em(i, j) = 0
                End If
            Next j
        Next i
        kmat = NumMat(ie)

        If KindElem = 0 Then
            numg = 0
            For ig = 1 To Ngaus
                s = PosGaus(ig)
                For jg = 1 To Ngaus
                    t = PosGaus(jg)
                    For kg = 1 To Ngaus
                        numg = numg + 1
                        u = PosGaus(kg)
                        Call ShapeFunc(1, s, t, u)         '形状関数の計算
                        Call JacobElem(ie, 0, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                        dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                        tempb = TG(numg)
                        Call StateCalc(kmat, kdiv, tempb)   '物性状態の計算
                        rc = Rou(kmat) * Cspec(kmat, kdiv)
                        rla = Rlamda(kmat, kdiv)
                        For i = 1 To Nvar
                            For j = i To Nvar
                                b1 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                                Ek(i, j) = Ek(i, j) + rla * b1 * dv
                                If Mstat > 0 Then
                                    b2 = rc * Shape(i) * Shape(j) * dv
                                    Em(i, j) = Em(i, j) + b2
                                End If
                            Next j
                        Next i
                    Next kg
                Next jg
            Next ig
        End If

        j = 0
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            k = Ndim * (Kcomp(i) - 1)
            For id = 1 To Ndim
                j = j + 1 : k = k + 1
                NPrefer(j) = k
            Next id
        Next ii

    End Sub

    Private Sub HeatFluxSet(ByVal istep As Integer)
        '熱流束の節点への換算
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim i, ib, ie, ii, j, jj, k1, k2, kb, kgp1, kgp2 As Integer
        Dim kind, kk, nmax, numg As Integer
        Dim b1, da, dj, pnb As Double
        Dim kbuf(8) As Integer
        Dim gpos(3) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To Nflux
            ie = KsurfFlux(ii, 1)
            kb = KsurfFlux(ii, 2)
            If KindElem = 0 Then
                Call SurfaceCond(kb, kind, kbuf, gpos)  '境界条件用の面設定
            End If

            For j = 1 To nmax
                ib = NNelem(ie, j)
                XE(j) = Xdata(ib)
                YE(j) = Ydata(ib)
                ZE(j) = Zdata(ib)
            Next j
            pnb = Pnorm(ii, istep)
            If KindElem = 0 Then
                Select Case kind
                    Case 1
                        kgp1 = 1
                        kgp2 = 2
                        jj = 3
                    Case 2
                        kgp1 = 1
                        kgp2 = 3
                        jj = 2
                    Case 3
                        kgp1 = 2
                        kgp2 = 3
                        jj = 1
                End Select

                numg = 0
                For k1 = 1 To Ngaus
                    gpos(kgp1) = PosGaus(k1)
                    For k2 = 1 To Ngaus
                        gpos(kgp2) = PosGaus(k2)
                        numg = numg + 1
                        Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                        '形状関数の計算

                        Call JacobElem2(ie, numg, dj, kbuf)
                        '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                        da = 0
                        For i = 1 To 3
                            b1 = RinvJ(i, jj)
                            da = da + b1 * b1
                        Next i
                        da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)
                        For i = 1 To 8
                            kk = kbuf(i)
                            j = Kcomp(NNelem(ie, kk))
                            Tf(j) = Tf(j) - pnb * Shape(kk) * da
                        Next i
                    Next k2
                Next k1
            End If
        Next ii

    End Sub

    Private Sub HeatTrans(ByVal istep As Integer)
        '熱伝達の計算
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim i, ib, ie, ii, it, itb, j, jj, jt, k, k1, k2 As Integer
        Dim kgp1, kgp2, kind, kk, kk1, kk2, kx, nmax, numg As Integer
        Dim alpb, b1, b2, b3, da, dj, tempb As Double
        Dim kbuf(8) As Integer
        Dim gpos(3) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To Namb
            ie = KsurfAmb(ii, 1)
            kx = KsurfAmb(ii, 2)
            If KindElem = 0 Then
                Call SurfaceCond(kx, kind, kbuf, gpos)  '境界条件用の面設定
            End If

            For j = 1 To nmax
                ib = NNelem(ie, j)
                XE(j) = Xdata(ib)
                YE(j) = Ydata(ib)
                ZE(j) = Zdata(ib)
            Next j
            alpb = Alpha(ii, istep)
            tempb = TempAmb(ii, istep)
            If KindElem = 0 Then
                Select Case kind
                    Case 1
                        kgp1 = 1
                        kgp2 = 2
                        jj = 3
                    Case 2
                        kgp1 = 1
                        kgp2 = 3
                        jj = 2
                    Case 3
                        kgp1 = 2
                        kgp2 = 3
                        jj = 1
                End Select

                numg = 0
                For k1 = 1 To Ngaus
                    gpos(kgp1) = PosGaus(k1)
                    For k2 = 1 To Ngaus
                        gpos(kgp2) = PosGaus(k2)
                        numg = numg + 1
                        Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                        '形状関数の計算

                        Call JacobElem2(ie, numg, dj, kbuf)
                        '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                        da = 0
                        For i = 1 To 3
                            b1 = RinvJ(i, jj)
                            da = da + b1 * b1
                        Next i
                        da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)
                        b1 = alpb * da
                        b2 = b1 * tempb
                        For i = 1 To 8
                            kk = kbuf(i)
                            j = Kcomp(NNelem(ie, kk))
                            Tf(j) = Tf(j) + b2 * Shape(kk)
                        Next i
                        For i = 1 To 8
                            kk1 = kbuf(i)
                            ib = Kcomp(NNelem(ie, kk1))
                            For j = i To 8
                                it = ib
                                kk2 = kbuf(j)
                                jt = Kcomp(NNelem(ie, kk2))
                                If it > jt Then
                                    itb = it
                                    it = jt
                                    jt = itb
                                End If
                                b3 = b1 * Shape(kk1) * Shape(kk2)
                                k = Idiag(jt) - jt + it
                                Tk(k) = Tk(k) + b3
                            Next j
                        Next i
                    Next k2
                Next k1
            End If
        Next ii

    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim i, ik, j As Integer
        Dim b1, tcmax, tcmin As Single

        If KindElem = 0 Then
            Nvar = 20
        End If
        Nall = Ndim * Npoint
        ReDim NPrefer(Nvar)
        ReDim Tf(Nall), Tu(Nall)

        Call BoundTempTreat()   '温度固定ﾃﾞｰﾀの処理

        If InitData > 0 Then
            For i = 1 To Npoint
                Tu(Kcomp(i)) = TempInit(i)
            Next i
        End If

        If Mstat > 0 Then
            ReDim Fc(Nall), TUx(Nall)
            For i = 1 To Nall
                TUx(i) = Tu(i)
            Next i
            Call CondTempCheck(ik, tcmax, tcmin)  '境界条件の温度ﾁｪｯｸ
            For i = 1 To Nall
                If i = 1 Then
                    TempIniMax = TUx(i)
                    TempIniMin = TUx(i)
                ElseIf TUx(i) < TempIniMin Then
                    TempIniMin = TUx(i)
                ElseIf TUx(i) > TempIniMax Then
                    TempIniMax = TUx(i)
                End If
            Next i
            KTempCond = 0
            If ik > 0 Then
                If TempIniMin < tcmin Then
                    KTempCond = 1
                ElseIf TempIniMax > tcmax Then
                    KTempCond = -1
                End If
            End If
            If KTempCond <> 0 And Nflux > 0 Then
                For i = 1 To Nflux
                    For j = 1 To Nstep
                        b1 = Pnorm(i, j)
                        If KTempCond > 0 And b1 > 0 Then
                            KTempCond = 0
                            Exit For
                        ElseIf KTempCond < 0 And b1 < 0 Then
                            KTempCond = 0
                            Exit For
                        End If
                    Next j
                    If KTempCond = 0 Then
                        Exit For
                    End If
                Next i
            End If
        End If

        PosGaus(3) = 0.77459667 : PosGaus(1) = -PosGaus(3) : PosGaus(2) = 0
        WeightG(1) = 0.55555556 : WeightG(3) = WeightG(1) : WeightG(2) = 0.88888889

    End Sub

    Private Sub InitialSet2(ByVal mb As Integer)
        '初期設定2
        Dim aa$
        Dim i, ib, ic, ie, ii, ip, j, j1, jb, nmax, num, numall As Integer
        Dim b1, freemem, reqmem As Single
        Dim nbuf(Npoint) As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        '関連節点数の計算
        numall = 0
        For i = 1 To Npoint
            j1 = i - mb + 1
            If j1 < 0 Then
                j1 = 1
            End If
            For j = j1 To i
                nbuf(j) = 0
            Next j
            ip = KRcomp(i)
            For ie = 1 To Nelem
                ic = 0
                For ii = 1 To nmax
                    If NNelem(ie, ii) = ip Then
                        ic = 1
                        Exit For
                    End If
                Next ii
                If ic > 0 Then
                    For ii = 1 To nmax
                        ib = Kcomp(NNelem(ie, ii))
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    Next ii
                End If
            Next ie
            jb = 0
            For j = j1 To i
                If nbuf(j) > 0 Then
                    jb = j
                    Exit For
                End If
            Next j
            If jb = 0 Then
                aa$ = "対象列が見当たらないエラーが発生しました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            num = i - jb + 1
            numall = numall + num
        Next i
        NumEff = numall

        ReDim Idiag(Nall)

        '保存配列との関連付け
        numall = 0
        For i = 1 To Npoint
            j1 = i - mb + 1
            If j1 < 0 Then
                j1 = 1
            End If
            For j = j1 To i
                nbuf(j) = 0
            Next j
            ip = KRcomp(i)
            For ie = 1 To Nelem
                ic = 0
                For ii = 1 To nmax
                    If NNelem(ie, ii) = ip Then
                        ic = 1
                        Exit For
                    End If
                Next ii
                If ic > 0 Then
                    For ii = 1 To nmax
                        ib = Kcomp(NNelem(ie, ii))
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    Next ii
                End If
            Next ie
            jb = 0
            For j = j1 To i
                If nbuf(j) > 0 Then
                    jb = j
                    Exit For
                End If
            Next j

            For j = jb To i
                numall = numall + 1
            Next j
            Idiag(i) = numall
        Next i

        freemem = 1000 * FreeMemoryGet()
        If Mstat = 0 Then
            reqmem = 8.0 * NumEff * 1.05
        Else
            If Nrad = 0 Then
                reqmem = 24.0 * NumEff * 1.05
            Else
                reqmem = 32.0 * NumEff * 1.05
            End If
        End If
        If reqmem > freemem Then
            b1 = reqmem / 100000000.0
            reqmem = (Int(b1) + 1) / 10
            aa$ = "変数の数が大き過ぎるため、配列変数のメモリーが足りません！"
            aa$ = aa$ + Chr(13) + Chr(10) + "スカイライン法で必要な空きメモリー容量は約"
            aa$ = aa$ + Str(reqmem) + "ＧＢです。"
            MsgBox(aa$, 0, "メモリー不足")
            End
        End If
        ReDim Tk(NumEff)
        If Mstat > 0 Then
            ReDim Rkc(NumEff), Rmc(NumEff)
            If Nrad > 0 Then
                ReDim Rkr(NumEff), Fr(Nall)
            End If
        End If

    End Sub

    Private Sub QHeat(ByVal istep As Integer)
        '内部発熱の計算
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim i, ib, ie, ig, ii, j, jg, k, kg, nmax, numg As Integer
        Dim dj, dv, qb, s, t, u As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To Nqint
            ie = Kelemq(ii)
            qb = Qint(ii, istep)
            For j = 1 To nmax
                ib = NNelem(ie, j)
                XE(j) = Xdata(ib)
                YE(j) = Ydata(ib)
                ZE(j) = Zdata(ib)
            Next j
            For i = 1 To nmax
                Qq(i) = 0
            Next i
            If KindElem = 0 Then
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            u = PosGaus(kg)
                            numg = numg + 1
                            Call ShapeFunc(1, s, t, u)         '形状関数の計算
                            Call JacobElem(ie, 0, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                            dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                            For i = 1 To 20
                                Qq(i) = Qq(i) + qb * Shape(i) * dv
                            Next i
                        Next kg
                    Next jg
                Next ig
            End If
            For k = 1 To nmax
                ib = Kcomp(NNelem(ie, k))
                Tf(ib) = Tf(ib) + Qq(k)
            Next k
        Next ii

    End Sub

    Private Sub RadGroup()
        '熱放射ｸﾞﾙｰﾌﾟの計算
        Dim i, ib, ie, ie2, ii, it, itb, j, jj, jj2, jt As Integer
        Dim k, k1, k2, kb1, kb2, kgp1, kgp2, kgx1, kgx2 As Integer
        Dim kind, kind2, kk, kk1, kk2, kp, kx, kx2, numg, numg2 As Integer
        Dim area1, area2, b1, b2, b3, b4, cas, cmin, cs1, cs2, da, da2 As Double
        Dim epsb, epsb2, gp1, gp2, rlen2, tb, tb2 As Double
        Dim kbuf(8), kbuf2(8) As Integer
        Dim cosb(2), snbuf(3), snbuf2(3), sdbuf(3) As Double
        Dim gpos(3), gpos2(3) As Double

        cmin = Math.Cos(89 * Pai / 180)
        For ii = 1 To NradG
            For k = 1 To NumRad(ii) - 1
                epsb = EpsRad(ii, k)
                ie = MemRad(ii, k, 1)
                kx = MemRad(ii, k, 2)
                Call SurfaceCond(kx, kind, kbuf, gpos)  '境界条件用の面設定

                For j = 1 To 20
                    ib = NNelem(ie, j)
                    XE(j) = Xdata(ib)
                    YE(j) = Ydata(ib)
                    ZE(j) = Zdata(ib)
                Next j
                Select Case kind
                    Case 1
                        kgp1 = 1
                        kgp2 = 2
                        jj = 3
                    Case 2
                        kgp1 = 1
                        kgp2 = 3
                        jj = 2
                    Case 3
                        kgp1 = 2
                        kgp2 = 3
                        jj = 1
                End Select

                For kk = k + 1 To NumRad(ii)
                    epsb2 = EpsRad(ii, kk)
                    ie2 = MemRad(ii, kk, 1)
                    kx2 = MemRad(ii, kk, 2)
                    Call SurfaceCond(kx2, kind2, kbuf2, gpos2)  '境界条件用の面設定

                    For j = 1 To 20
                        ib = NNelem(ie2, j)
                        XE2(j) = Xdata(ib)
                        YE2(j) = Ydata(ib)
                        ZE2(j) = Zdata(ib)
                    Next j

                    Select Case kind2
                        Case 1
                            kgx1 = 1
                            kgx2 = 2
                            jj2 = 3
                        Case 2
                            kgx1 = 1
                            kgx2 = 3
                            jj2 = 2
                        Case 3
                            kgx1 = 2
                            kgx2 = 3
                            jj2 = 1
                    End Select

                    numg = 0
                    For k1 = 1 To Ngaus
                        gpos(kgp1) = PosGaus(k1)
                        For k2 = 1 To Ngaus
                            gpos(kgp2) = PosGaus(k2)
                            numg = numg + 1
                            Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                            '形状関数の計算

                            Call JacobElem2M(numg, kbuf, Shape, XE, YE, ZE, XG, YG, ZG, Ds, Dt, Du)
                            '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                            da = 0
                            For i = 1 To 3
                                b1 = RinvJ(i, jj)
                                da = da + b1 * b1
                            Next i
                            area1 = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)

                            tb = 0
                            For i = 1 To 8
                                kp = kbuf(i)
                                j = Kcomp(NNelem(ie, kp))
                                tb = tb + Shape(kp) * Tu(j)
                            Next i

                            gp1 = gpos(kgp1)
                            gp2 = gpos(kgp2)
                            Call VectorCalc(kind, numg, gp1, gp2, kbuf, gpos, XE, YE, ZE, XG, YG, ZG, snbuf)
                            '面の法線ﾍﾞｸﾄﾙ算出

                            numg2 = 0
                            For kk1 = 1 To Ngaus
                                gpos2(kgx1) = PosGaus(kk1)
                                For kk2 = 1 To Ngaus
                                    gpos2(kgx2) = PosGaus(kk2)
                                    numg2 = numg2 + 1
                                    Call ShapeFunc2(1, gpos2(1), gpos2(2), gpos2(3), Shape2, Ds2, Dt2, Du2)
                                    '形状関数の計算

                                    Call JacobElem2M(numg2, kbuf2, Shape2, XE2, YE2, ZE2, XG2, YG2, ZG2, Ds2, Dt2, Du2)
                                    '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                                    da2 = 0
                                    For i = 1 To 3
                                        b1 = RinvJ(i, jj2)
                                        da2 = da2 + b1 * b1
                                    Next i
                                    area2 = Math.Sqrt(da2) * WeightG(kk1) * WeightG(kk2)

                                    tb2 = 0
                                    For i = 1 To 8
                                        kp = kbuf2(i)
                                        j = Kcomp(NNelem(ie2, kp))
                                        tb2 = tb2 + Shape2(kp) * Tu(j)
                                    Next i

                                    gp1 = gpos2(kgx1)
                                    gp2 = gpos2(kgx2)
                                    Call VectorCalc(kind2, numg2, gp1, gp2, kbuf2, gpos2, XE2, YE2, ZE2, XG2, YG2, ZG2, snbuf2)
                                    '面の法線ﾍﾞｸﾄﾙ算出

                                    Call VectorCalG(numg, numg2, rlen2, sdbuf)   'ｶﾞｳｽ点間ﾍﾞｸﾄﾙ算出

                                    b1 = snbuf(1) * sdbuf(1) + snbuf(2) * sdbuf(2) + snbuf(3) * sdbuf(3)
                                    b2 = snbuf2(1) * sdbuf(1) + snbuf2(2) * sdbuf(2) + snbuf2(3) * sdbuf(3)
                                    cosb(1) = b1
                                    cosb(2) = -b2
                                    If cosb(1) < cmin Or cosb(2) < cmin Then
                                        Exit For
                                    End If

                                    b1 = cosb(1) * cosb(2) / (Pai * rlen2)
                                    cs1 = b1 * area2
                                    cs2 = b1 * area1
                                    cas = area1 * cs1

                                    b1 = SigmaG * (tb + tb2) * (tb * tb + tb2 * tb2)
                                    b2 = (1 - epsb) / (epsb * area1) + 1 / cas + (1 - epsb2) / (epsb2 * area2)
                                    b3 = b1 / b2

                                    For i = 1 To 8
                                        kb1 = kbuf(i)
                                        ib = Kcomp(NNelem(ie, kb1))
                                        For j = i To 8
                                            it = ib
                                            kb2 = kbuf(j)
                                            jt = Kcomp(NNelem(ie, kb2))
                                            If it > jt Then
                                                itb = it
                                                it = jt
                                                jt = itb
                                            End If
                                            b4 = b3 * Shape(kb1) * Shape(kb2)
                                            kp = Idiag(jt) - jt + it
                                            Tk(kp) = Tk(kp) + b4
                                        Next j
                                        Tf(ib) = Tf(ib) + b3 * Shape(kb1) * tb2
                                    Next i

                                    For i = 1 To 8
                                        kb1 = kbuf2(i)
                                        ib = Kcomp(NNelem(ie2, kb1))
                                        For j = i To 8
                                            it = ib
                                            kb2 = kbuf2(j)
                                            jt = Kcomp(NNelem(ie2, kb2))
                                            If it > jt Then
                                                itb = it
                                                it = jt
                                                jt = itb
                                            End If
                                            b4 = b3 * Shape2(kb1) * Shape2(kb2)
                                            kp = Idiag(jt) - jt + it
                                            Tk(kp) = Tk(kp) + b4
                                        Next j
                                        Tf(ib) = Tf(ib) + b3 * Shape2(kb1) * tb
                                    Next i

                                Next kk2

                            Next kk1
                        Next k2
                    Next k1

                Next kk

            Next k
        Next ii

    End Sub

    Private Sub Radiation(ByVal istep As Integer)
        '熱放射の計算
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim i, ib, ie, ii, it, itb, j, jj, jt, k, k1, k2 As Integer
        Dim kgp1, kgp2, kind, kk, kk1, kk2, kx, nmax, numg As Integer
        Dim b1, b2, b3, da, dj, radb, tb, tt As Double
        Dim kbuf(8) As Integer
        Dim gpos(3) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To Nrad
            ie = KsurfRad(ii, 1)
            kx = KsurfRad(ii, 2)
            If KindElem = 0 Then
                Call SurfaceCond(kx, kind, kbuf, gpos)  '境界条件用の面設定
            End If

            For j = 1 To nmax
                ib = NNelem(ie, j)
                XE(j) = Xdata(ib)
                YE(j) = Ydata(ib)
                ZE(j) = Zdata(ib)
            Next j
            radb = RadRate(ii, istep)
            tt = TempRad(ii, istep)
            If KindElem = 0 Then
                Select Case kind
                    Case 1
                        kgp1 = 1
                        kgp2 = 2
                        jj = 3
                    Case 2
                        kgp1 = 1
                        kgp2 = 3
                        jj = 2
                    Case 3
                        kgp1 = 2
                        kgp2 = 3
                        jj = 1
                End Select

                numg = 0
                For k1 = 1 To Ngaus
                    gpos(kgp1) = PosGaus(k1)
                    For k2 = 1 To Ngaus
                        gpos(kgp2) = PosGaus(k2)
                        numg = numg + 1
                        Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                        '形状関数の計算

                        Call JacobElem2(ie, numg, dj, kbuf)
                        '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                        da = 0
                        For i = 1 To 3
                            b1 = RinvJ(i, jj)
                            da = da + b1 * b1
                        Next i
                        da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)

                        tb = 0
                        For i = 1 To 8
                            kk = kbuf(i)
                            j = Kcomp(NNelem(ie, kk))
                            tb = tb + Shape(kk) * Tu(j)
                        Next i
                        b1 = radb * da * (tb + tt) * (tb * tb + tt * tt)
                        b2 = b1 * tt
                        For i = 1 To 8
                            kk = kbuf(i)
                            j = Kcomp(NNelem(ie, kk))
                            If Mstat = 0 Then
                                Tf(j) = Tf(j) + b2 * Shape(kk)
                            Else
                                Fr(j) = Fr(j) + b2 * Shape(kk)
                            End If
                        Next i
                        For i = 1 To 8
                            kk1 = kbuf(i)
                            ib = Kcomp(NNelem(ie, kk1))
                            For j = i To 8
                                it = ib
                                kk2 = kbuf(j)
                                jt = Kcomp(NNelem(ie, kk2))
                                If it > jt Then
                                    itb = it
                                    it = jt
                                    jt = itb
                                End If
                                b3 = b1 * Shape(kk1) * Shape(kk2)
                                k = Idiag(jt) - jt + it
                                If Mstat = 0 Then
                                    Tk(k) = Tk(k) + b3
                                Else
                                    Rkr(k) = Rkr(k) + b3
                                End If
                            Next j
                        Next i
                    Next k2
                Next k1
            End If
        Next ii

    End Sub

    Private Sub ReqTime(ByVal rmesh As Single, ByVal rmeshsum As Single, _
        ByVal b1 As Double, ByVal b2 As Single)
        '残りの所要時間の計算
        'rmesh･･･ﾒｯｼｭ番号
        'rmeshsum･･･最大ﾒｯｼｭ番号
        'b1･･･熱伝導の時間差
        'b2･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b3, b4 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics

        tima$ = ""
        If b2 < 0 Then
            b2 = b2 + 86400
        End If
        b3 = rmeshsum - rmesh
        If Nstep = 1 Then
            b3 = TimeMax * b3 / rmeshsum
        End If
        b4 = b2 * b3 / b1
        Call TimConv(tima$, b4)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力1
        'UTF-8･･･BOMなし
        Dim aa$

        SwK = New IO.StreamWriter(Fy$)  '結果出力用
        SwK.WriteLine("＜＜３次元熱伝導解析の計算結果＞＞")
        SwK.WriteLine(Title$)

        aa$ = "［入力データファイル］" + "," + Fm$
        SwK.WriteLine(aa$)
        aa$ = "解析種類（0:定常、1:非定常）" + "," + Str(Mstat)
        SwK.WriteLine(aa$)
        If Mstat > 0 Then
            If Nstep = 1 Then
                aa$ = "計算打切り時間" + "," + Str(TimeMax) + ", "
                aa$ = aa$ + "出力時間メッシュ数" + "," + Str(Ntime)
                SwK.WriteLine(aa$)
            Else
                aa$ = "計算サイクル数" + "," + Str(Ncycle) + ","
                aa$ = aa$ + "出力サイクル間隔" + "," + Str(Idcycle)
                SwK.WriteLine(aa$)
                aa$ = "境界条件のステップ数" + "," + Str(Nstep)
                SwK.WriteLine(aa$)
            End If
            aa$ = "計算時間間隔の初期値" + "," + Str(DtimeInit) + ","
            aa$ = aa$ + "計算1回の温度変化許容値" + "," + Str(DtempMax)
            SwK.WriteLine(aa$)
        End If

        SwK.WriteLine("-----------------------------------------------")

    End Sub

    Private Sub ResFile2(ByVal mb As Integer)
        '結果ﾌｧｲﾙへの出力2
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$

        aa$ = "＊＊＊ 計算結果（スカイライン法、主行列"
        If Mstat = 0 Then
            aa$ = aa$ + "１個"
        ElseIf Nrad = 0 Then
            aa$ = aa$ + "３個"
        Else
            aa$ = aa$ + "４個"
        End If
        aa$ = aa$ + "） ＊＊＊"
        SwK.WriteLine(aa$)
        aa$ = "バンド幅" + "," + Str(mb)
        SwK.WriteLine(aa$)
        aa$ = "保存配列のインデックス数" + "," + Str(NumEff)
        SwK.WriteLine(aa$)
        SwK.WriteLine("-----------------------------------------------")

    End Sub

    Private Sub ResFile3(ByVal itime As Integer, ByVal icycle As Integer, _
        ByVal istep As Integer)
        '結果ﾌｧｲﾙへの出力3
        'itime･･･時間ﾒｯｼｭ番号
        'icycle･･･ｻｲｸﾙ番号
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim aa$
        Dim i1, ic, ii, ip As Integer
        Dim b1, b2, z1 As Single

        If Mstat > 0 Then
            If Nstep = 1 Then
                aa$ = "＜時間メッシュ番号、時間＞" + ","
                aa$ = aa$ + Str(itime) + "," + Str(TimeNew)
            Else
                aa$ = "＜サイクル番号、ステップ番号、時間＞" + "," + Str(icycle)
                aa$ = aa$ + "," + Str(istep) + "," + Str(TimeNew)
            End If
            SwK.WriteLine(aa$)
        End If
        SwK.WriteLine("＜節点番号、温度＞")

        ic = 0
        If Mstat = 0 Or TimeNew = 0 Then
            ic = 1
        End If

        For ip = 1 To Npoint
            ii = Kcomp(ip)
            b1 = Tu(ii)
            i1 = Int(b1)
            b2 = b1 - i1
            z1 = CInt(b2 * 100) / 100 + i1
            aa$ = Str$(ip) + ",  " + Str$(z1)
            SwK.WriteLine(aa$)
            If ic > 0 Then
                KTempRange(1) = 1
                KTempRange(2) = 1
                TempRange(1) = z1
                TempRange(2) = z1
                TTempRange(1) = 0
                TTempRange(2) = 0
                ic = 0
            ElseIf z1 < TempRange(1) Then
                KTempRange(1) = ip
                TempRange(1) = z1
                TTempRange(1) = TimeNew
            ElseIf z1 > TempRange(2) Then
                KTempRange(2) = ip
                TempRange(2) = z1
                TTempRange(2) = TimeNew
            End If
        Next ip

    End Sub

    Private Sub ResFile4()
        '結果ﾌｧｲﾙへの出力4
        Dim aa$, ad$
        Dim i As Integer
        ad$ = "-------------------------------------------------------"
        If Mstat = 0 Then
            aa$ = "変数項目、  値、              節点番号"
        Else
            aa$ = "変数項目、  値、              節点番号、   時間"
        End If
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜最低・最高温度データ＞")
        SwK.WriteLine(aa$)
        CalcRes$ = "＜最低・最高温度データ＞" + Cr$ + aa$
        For i = 1 To 2
            Select Case i
                Case 1
                    aa$ = "TempMin"
                Case 2
                    aa$ = "TempMax"
            End Select
            aa$ = aa$ + ",  "
            aa$ = aa$ + Space$(12 - Len(aa$)) + Str$(TempRange(i)) + ",  "
            If Mstat = 0 Then
                aa$ = aa$ + Space$(32 - Len(aa$)) + Str$(KTempRange(i))
            Else
                aa$ = aa$ + Space$(32 - Len(aa$)) + Str$(KTempRange(i)) + ",  "
                aa$ = aa$ + Space$(44 - Len(aa$)) + Str$(TTempRange(i))
            End If
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Cr$ + aa$
        Next i

    End Sub

    Private Sub RestCond(ByVal k As Integer, ByVal mb As Integer, _
    ByVal ub As Double)
        '拘束条件処理
        'k･･･変数番号
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'ub･･･拘束値
        Dim it, j, k1, mx As Integer
        If k > 1 Then
            For j = Idiag(k - 1) + 1 To Idiag(k) - 1
                If ub <> 0 Then
                    it = k - Idiag(k) + j
                    Tf(it) = Tf(it) - Tk(j) * ub
                End If
                Tk(j) = 0
            Next j
        End If
        If k < Nall Then
            mx = mb
            If k + mb - 1 > Nall Then
                mx = Nall - k + 1
            End If
            For j = 2 To mx
                k1 = Idiag(k + j - 1) - j + 1
                If k1 > Idiag(k + j - 2) Then
                    If ub <> 0 Then
                        it = k + j - 1
                        Tf(it) = Tf(it) - Tk(k1) * ub
                    End If
                    Tk(k1) = 0
                End If
            Next j
        End If
        Tk(Idiag(k)) = 1
        Tf(k) = ub

    End Sub

    Private Sub Solver1()
        'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）
        Dim aa$, timn$
        Dim i, i0, icount, ii, ij, ik, jk, j, j0, jj, jm1, k, kk, mi, mij, mj As Integer
        Dim sum As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        Application.DoEvents()
        icount = 0
        For i = 2 To Nall
            i0 = Idiag(i) - i
            mi = Idiag(i - 1) - i0 + 1
            For j = mi To i
                sum = 0
                j0 = Idiag(j) - j
                mj = 1
                If j > 1 Then
                    mj = Idiag(j - 1) - j0 + 1
                End If
                mij = mi
                If mj > mi Then
                    mij = mj
                End If
                ij = i0 + j
                jm1 = j - 1
                For k = mij To jm1
                    If mij <= jm1 Then
                        ik = i0 + k
                        kk = Idiag(k)
                        jk = j0 + k
                        sum = sum + Tk(ik) * Tk(kk) * Tk(jk)
                    End If
                Next k
                If j = i Then
                    ii = i0 + i
                    Tk(ii) = Tk(ii) - sum
                Else
                    jj = Idiag(j)
                    Tk(ij) = (Tk(ij) - sum) / Tk(jj)
                End If
            Next j
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next i

        gr.Dispose()

    End Sub

    Private Sub Solver2(ByVal mh As Integer)
        'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim i, i0, j, j0, j1, j2, j3, k As Integer
        Dim b1, eps, sum As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        eps = 1.0E-32
        For i = 2 To Nall
            sum = 0
            i0 = Idiag(i) - i
            j1 = Idiag(i - 1) - i0 + 1
            j2 = i - 1
            If j1 <> i Then
                For j = j1 To j2
                    j0 = i0 + j
                    sum = sum + Tk(j0) * Tf(j)
                Next j
            End If
            Tf(i) = Tf(i) - sum
        Next i

        For i = 1 To Nall
            b1 = Tk(Idiag(i))
            If Math.Abs(b1) < eps Then
                aa$ = "ｿﾙﾊﾞｰ2でﾋﾟﾎﾞｯﾄが0になりました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            Tf(i) = Tf(i) / b1
        Next i

        For k = Nall - 1 To 1 Step -1
            j1 = k + 1
            j2 = j1 + mh - 1
            If j2 > Nall Then
                j2 = Nall
            End If
            sum = 0
            For j = j1 To j2
                j3 = Idiag(j - 1) - Idiag(j) + j + 1
                If j3 <= k Then
                    j0 = Idiag(j) - j + k
                    sum = sum + Tk(j0) * Tf(j)
                End If
            Next j
            Tf(k) = Tf(k) - sum
        Next k

        gr.Dispose()

    End Sub

    Private Sub StateCalc(ByVal kmat As Integer, ByRef kdiv As Integer, _
        ByVal tempmesh As Double)
        '物性状態の計算
        'kmat･･･材料番号
        'kdiv･･･物性区分番号
        'tempmesh･･･現在温度
        Dim i As Integer
        For i = 1 To NMdiv(kmat)
            kdiv = i
            If tempmesh <= TempMat(kmat, i) Then
                Exit For
            End If
        Next i
    End Sub

    Private Sub Store()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, ib, it, j, jt, k As Integer
        For i = 1 To Nvar
            For j = i To Nvar
                it = NPrefer(i) : jt = NPrefer(j)
                If it > jt Then
                    ib = it
                    it = jt
                    jt = ib
                End If
                k = Idiag(jt) - jt + it
                If Mstat = 0 Then
                    Tk(k) = Tk(k) + Ek(i, j)
                Else
                    Rkc(k) = Rkc(k) + Ek(i, j)
                    Rmc(k) = Rmc(k) + Em(i, j)
                End If
            Next j
        Next i

    End Sub

    Private Sub TempCheck()
        '温度ﾁｪｯｸ
        Dim i As Integer
        For i = 1 To Nall
            If KTempCond > 0 Then
                If Tu(i) < TempIniMin Then
                    Tu(i) = TempIniMin
                End If
            Else
                If Tu(i) > TempIniMax Then
                    Tu(i) = TempIniMax
                End If
            End If
        Next i

    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub Th3DCal4_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, timn$
        Dim i, ib, icc, icheck, icount, icycle, ie, ii, istep, itime, ix As Integer
        Dim j, j1, j2, k, kb, kxcycle, mb, mbx, newstep As Integer
        Dim df, drmesh, freemem, fw0, fwx As Single
        Dim rmesh, rmeshsum, sec, timenewb As Single
        Dim date0, date1, date2 As Date
        Dim b1, dtempx, dtime0, dtime1, dtimestd As Double
        Dim time0, time1, time2, timenext, ub As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        timn$ = ""
        Call TimCal(0, timn$)

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""
        Me.Refresh()

        Fw1 = 0 : Fw2 = 100

        Call ResFile1U()     '結果ﾌｧｲﾙへの出力1

        aa$ = "初期設定処理  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Dim xbuf(Npoint), ybuf(Npoint), zbuf(Npoint) As Single
        Call AxisValueTreat(xbuf, ybuf, zbuf)   '座標値の端数処理
        ReDim Kcomp(Npoint), KRcomp(Npoint)
        For i = 1 To Npoint
            Kcomp(i) = i
        Next i
        Call BandWidth2(mbx, Kcomp)  'ﾊﾞﾝﾄﾞ幅の計算
        Call PnumImproveNew(mb, mbx, xbuf, ybuf, zbuf)  '節点順序の改良
        Erase xbuf, ybuf, zbuf
        Application.DoEvents()

        Call InitialSet1()  '初期設定

        Call InitialSet2(mb)    '初期設定2

        Call ResFile2(mb)   '結果ﾌｧｲﾙへの出力2

        If Mstat > 0 Then
            If Nstep = 1 Then
                df = (Fw2 - Fw1) / Ntime
                rmeshsum = Ntime     'ﾒｯｼｭ合計
            Else
                b1 = 0
                For i = 1 To Nstep
                    b1 = b1 + TimeStep(i)
                Next i
                rmeshsum = Ncycle * b1   'ﾒｯｼｭ合計
                df = (Fw2 - Fw1) / rmeshsum
            End If
        End If

        If Nflux > 0 Then
            Call HeatFluxSet(1)    '熱流束の設定
        End If

        itime = 0
        If Mstat > 0 Then   '非定常の場合
            TimeNew = 0
            itime = 0
            icycle = 0
            istep = 0
            Call ResFile3(itime, icycle, istep) '結果ﾌｧｲﾙへの出力3

            Dim rdate As Date = Now
            date1 = rdate
            time1 = 0
            date2 = date1
            time2 = 0
            itime = 1
            icycle = 1
            Dtime = DtimeInit
            dtime0 = Dtime
            If Nstep = 1 Then
                dtimestd = TimeMax / Ntime
            Else
                dtimestd = TimeStep(1)
                kxcycle = Idcycle
                time0 = 0
                date0 = date1
            End If
            TimeNew = Dtime
            timenext = dtimestd
            newstep = 0
        End If
        istep = 1

        If Namb > 0 Then
            Call HeatTrans(1)  '熱伝達の計算
        End If

        If Nqint > 0 Then
            Call QHeat(1)      '内部発熱の計算
        End If

        If Mstat > 0 Then   '非定常の場合
            For i = 1 To Nall
                Fc(i) = Tf(i)
            Next i
            For i = 1 To NumEff
                Rkc(i) = Tk(i)
            Next i
            If Nrad > 0 Then
                Call Radiation(1)  '熱放射の計算
            End If
        End If

        aa$ = "要素計算中" + "   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            Call ElemMatrix(ie)     '要素ﾏﾄﾘｯｸｽの計算
            Call Store()    '全体ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        If Mstat = 0 Then
            '進行表示
            fw0 = Fw1
            fwx = 0.7 * Fw1 + 0.3 * Fw2
            ProgressBar1.Value = 100 * fwx / Fw2
        End If

        icheck = 0
        Do
            If Mstat > 0 Then
                Application.DoEvents()
                icount = 0
                For k = 1 To Nall
                    Tf(k) = 2 * Fc(k)
                    If Nrad > 0 Then
                        Tf(k) = Tf(k) + 2 * Fr(k)
                    End If
                    j1 = Idiag(k - 1) + 1
                    j2 = Idiag(k)
                    For ii = j1 To j2
                        b1 = Rkc(ii)
                        If Nrad > 0 Then
                            b1 = b1 + Rkr(ii)
                        End If
                        j = k - (j2 - ii)
                        Tf(k) = Tf(k) - (b1 - Rmc(ii) * 2 / Dtime) * Tu(j)
                    Next ii
                    If k < Nall Then
                        j = k + mb - 1
                        If j > Nall Then
                            j = Nall
                        End If
                        For kb = k + 1 To j
                            j1 = Idiag(kb)
                            j2 = kb - k
                            If j1 - Idiag(kb - 1) > j2 Then
                                ii = j1 - j2
                                b1 = Rkc(ii)
                                If Nrad > 0 Then
                                    b1 = b1 + Rkr(ii)
                                End If
                                Tf(k) = Tf(k) - (b1 - Rmc(ii) * 2 / Dtime) * Tu(kb)
                            End If
                        Next kb
                    End If
                    If icount < 999 Then
                        icount = icount + 1
                    Else
                        Application.DoEvents()
                        icount = 0
                    End If
                Next k
                For ii = 1 To NumEff
                    Tk(ii) = Rkc(ii) + Rmc(ii) * 2 / Dtime
                    If Nrad > 0 Then
                        Tk(ii) = Tk(ii) + Rkr(ii)
                    End If
                Next ii

                If NradG > 0 Then
                    Call RadGroup()  '熱放射ｸﾞﾙｰﾌﾟの計算
                End If
            End If

            If Nbound > 0 Then
                For ib = 1 To Nbound
                    ix = Nrest(ib)
                    k = Kcomp(ix)
                    ub = TempFix(ib, istep)
                    If ub > -998.9 Then
                        Call RestCond(k, mb, ub)     '拘束条件処理
                    End If
                Next ib
            End If

            Call Solver1()  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）

            Call Solver2(mb)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）

            For i = 1 To Nall
                Tu(i) = Tf(i)
            Next i
            If Mstat > 0 And KTempCond <> 0 Then
                Call TempCheck()    '温度ﾁｪｯｸ
            End If

            Application.DoEvents()
            If Mstat = 0 Then       '定常の場合
                Call ResFile3(itime, icycle, istep)      '結果ﾌｧｲﾙへの出力3
                icheck = 1
            Else                    '非定常の場合
                If Nstep = 1 Then
                    date0 = date1
                    time0 = time1
                End If
                date1 = date2
                time1 = time2
                Dim rdate1 As Date = Now
                date2 = rdate1
                time2 = TimeNew
                If TimeNew > 0.9999 * timenext Then
                    TimeNew = timenext
                    If Nstep = 1 Then
                        icc = 1
                    ElseIf icycle = kxcycle Then
                        icc = 1
                        If istep = Nstep Then
                            kxcycle = kxcycle + Idcycle
                            If kxcycle > Ncycle Then
                                kxcycle = Ncycle
                            End If
                        End If
                    Else
                        icc = 0
                    End If
                    If icc > 0 Then
                        Call ResFile3(itime, icycle, istep)  '結果ﾌｧｲﾙへの出力3
                    End If

                    If Nstep = 1 Then
                        rmesh = itime
                    Else
                        drmesh = timenext - rmesh
                        rmesh = timenext
                    End If
                    If Nstep = 1 Then
                        b1 = time1 - time0
                        If b1 >= Dtime Then
                            sec = TimeLap(date0, date1)
                        Else
                            b1 = Dtime
                            sec = TimeLap(date1, date2)
                        End If
                    Else
                        b1 = time2 - time0
                        sec = TimeLap(date0, date2)
                    End If
                    Call ReqTime(rmesh, rmeshsum, b1, sec)   '残りの所要時間の計算

                    '進行表示
                    fw0 = Fw1
                    If Nstep = 1 Then
                        Fw1 = Fw1 + df
                    Else
                        Fw1 = Fw1 + drmesh * df
                    End If
                    ProgressBar1.Value = 100 * Fw1 / Fw2

                    If Nstep = 1 Then
                        itime = itime + 1
                        timenext = TimeMax * itime / Ntime
                    Else
                        If istep < Nstep Then
                            istep = istep + 1
                        Else
                            icycle = icycle + 1
                            istep = 1
                        End If
                        timenext = timenext + TimeStep(istep)
                        newstep = 1
                    End If
                End If
                If Nstep = 1 Then
                    If itime > Ntime Then
                        icheck = 1
                    End If
                ElseIf icycle > Ncycle Then
                    icheck = 1
                End If
                timenewb = TimeNew
                If icheck = 0 Then
                    If dtime0 < dtimestd Then
                        Call DtempCalc(dtempx)      '最大温度変化の計算
                        If dtime0 = Dtime Then
                            If dtempx = 0 Or dtempx < 0.5 * DtempMax Then
                                dtime0 = 2 * Dtime
                            End If
                            If dtime0 > 0.999 * dtimestd Then
                                dtime0 = dtimestd
                            End If
                        End If
                        For i = 1 To Nall
                            TUx(i) = Tu(i)
                        Next i
                    End If
                    dtime1 = timenext - TimeNew
                    If newstep = 0 Then
                        If dtime1 < 1.001 * dtime0 Then
                            Dtime = dtime1
                        Else
                            Dtime = dtime0
                        End If
                    Else
                        Dim rdate2 As Date = Now
                        date1 = rdate2
                        time1 = TimeNew
                        date2 = date1
                        time2 = 0
                        time0 = time1
                        date0 = date1
                        Dtime = DtimeInit
                        dtime0 = Dtime
                        dtimestd = TimeStep(istep)
                    End If
                    TimeNew = TimeNew + Dtime

                    If NMdivMax > 1 Or newstep > 0 Then
                        newstep = 0
                        For i = 1 To Nall
                            Tf(i) = 0
                            Fc(i) = 0
                        Next i
                        For ii = 1 To NumEff
                            Tk(ii) = 0
                            Rkc(ii) = 0
                            Rmc(ii) = 0
                        Next ii
                        If Nflux > 0 Then
                            Call HeatFluxSet(istep)    '熱流束の設定
                        End If
                        If Namb > 0 Then
                            Call HeatTrans(istep)  '熱伝達の計算
                        End If
                        If Nqint > 0 Then
                            Call QHeat(istep)      '内部発熱の計算
                        End If
                        For i = 1 To Nall
                            Fc(i) = Tf(i)
                        Next i
                        For ii = 1 To NumEff
                            Rkc(ii) = Tk(ii)
                        Next ii

                        aa$ = "要素計算中" + "   "
                        Call TimCal(1, timn$)
                        aa$ = aa$ + timn$
                        gr.Clear(Color.White)
                        gr.DrawString(aa$, fnt, myBrush, 1, 1)

                        Application.DoEvents()
                        icount = 0
                        For ie = 1 To Nelem
                            Call ElemMatrix(ie)     '要素ﾏﾄﾘｯｸｽの計算
                            Call Store()    '全体ﾏﾄﾘｯｸｽへの蓄積
                            If icount < 99 Then
                                icount = icount + 1
                            Else
                                Application.DoEvents()
                                icount = 0
                            End If
                        Next ie
                    End If
                    If Nrad > 0 Then
                        For i = 1 To Nall
                            Fr(i) = 0
                        Next i
                        For ii = 1 To NumEff
                            Rkr(ii) = 0
                        Next ii
                        Call Radiation(istep)  '熱放射の計算
                    End If
                End If
            End If

            aa$ = "ﾙｰﾌﾟ終了" + "   "
            If Mstat > 0 Then
                aa$ = "時間" + Str(timenewb) + "   " + aa$
            End If
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Loop Until icheck = 1

        Call ResFile4()     '結果ﾌｧｲﾙへの出力4

        '進行表示
        ProgressBar1.Value = 100

        Call TimCal(1, timn$)
        freemem = Int(FreeMemoryGet() / 1000.0)
        aa$ = "END   " + timn$ + "   " + Str(freemem) + "MB free"
        SwK.WriteLine(aa$)
        SwK.Close()

        Label1.Text = "計算終了！"
        Label2.Text = "計算結果をファイルへ出力しました。"
        Label3.Text = aa$
        aa$ = "計算が終了しました。"
        Me.BringToFront()
        aa$ = aa$ + Chr(13) + Chr(10) + CalcRes$
        If KindBatch = 0 Then
            MsgBox(aa$, 0, "計算確認")
        Else
            Kfinish = 1
        End If

        gr.Dispose()
        Me.Close()

    End Sub
End Class
